// @ts-nocheck
// #ifndef APP-IOS || APP-ANDROID
interface CSSProperties {
	[key : string] : string | number | null
}
// #endif

// #ifdef VUE3
// #ifdef APP-IOS || APP-ANDROID
type CSSProperties = UTSJSONObject
// #endif
// #endif
/**
 * 將字符串轉換為帶有連字符分隔的小寫形式
 * @param key - 要轉換的字符串
 * @returns 轉換後的字符串
 */
export function toLowercaseSeparator(key : string):string {
	return key.replace(/([A-Z])/g, '-$1').toLowerCase();
}

/**
 * 獲取樣式對象對應的樣式字符串
 * @param style - CSS樣式對象
 * @returns 由非空有效樣式屬性鍵值對組成的字符串
 */
export function getStyleStr(style : CSSProperties) : string {
	
	// #ifdef APP-IOS || APP-ANDROID
	let styleStr = '';
	style.toMap().forEach((value, key) => {
		if(value !== null && value != '') {
			styleStr += `${toLowercaseSeparator(key as string)}: ${value};`
		}
	})
	return styleStr
	// #endif
	// #ifndef APP-IOS || APP-ANDROID
	return Object.keys(style)
		.filter(
			(key) => 
				style[key] !== undefined && 
				style[key] !== null && 
				style[key] !== '')
		.map((key : string) => `${toLowercaseSeparator(key)}: ${style[key]};`)
		.join(' ');
	// #endif
}

// 示例
// const style = { color: 'red', fontSize: '16px', backgroundColor: '', border: null };
// const styleStr = getStyleStr(style);
// console.log(styleStr);
// 輸出: "color: red; font-size: 16px;"